﻿'データベース操作用モジュール
'作成者：　難波　秀文
'作成日：　2013年1月4日
'概要：
'　データベースMySQLにMySQL Connector NETを用いてアクセスする関数群です。
'　Open/Closeを除くとたったの3つしか関数がありませんが、簡単なプログラムならこれで事足ります。

Imports MySql.Data.MySqlClient

Module DataBaseModule
    Public Function Open(ByRef myConn As MySqlConnection, ByVal connectionString As String) As Boolean
        Open = False
        Try
            myConn.ConnectionString = connectionString
            myConn.Open()
            Open = True
        Catch ex As MySqlException
            Open = False
            Debug.Print("[" & Now() & "]" & "Open関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        End Try
    End Function

    Public Sub Close(ByRef myConn As MySqlConnection)
        Try
            myConn.Close()
        Catch ex As MySqlException
            Debug.Print("[" & Now() & "]" & "Close関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        End Try
    End Sub

    Public Function ExecuteNonQuery(ByRef myConn As MySqlConnection, ByVal strSqlCommand As String) As Boolean
        Dim myCommand As New MySqlCommand(strSqlCommand, myConn)
        ExecuteNonQuery = False
        Try
            myCommand.ExecuteNonQuery()
            ExecuteNonQuery = True
        Catch ex As MySqlException
            Debug.Print("[" & Now() & "]" & "ExecuteNonQuery関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        End Try
    End Function

    Public Function NonQueryCommand(ByVal myConnectionString As String, ByVal strSQL As String) As Boolean
        Dim myConnection As New MySqlConnection(myConnectionString)
        NonQueryCommand = False
        Try
            myConnection.Open()
            Dim myCommand As New MySqlCommand(strSQL, myConnection)
            myCommand.ExecuteNonQuery()
            myConnection.Close()
            NonQueryCommand = True
        Catch ex As MySqlException
            Debug.Print("[" & Now() & "]" & "NonQueryCommand関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        Catch ex As Exception
            Debug.Print("[" & Now() & "]" & "NonQueryCommand関数を実行中に例外発生 " & ex.Message)
        End Try
    End Function

    Public Function FillTable(ByRef dataset As DataSet, _
                         ByVal strTableName As String, _
                         ByVal myConnectionString As String) As Boolean
        Dim myConnection As New MySqlConnection(myConnectionString)
        FillTable = False
        Try
            myConnection.Open()
            Dim adapter As New MySqlDataAdapter()
            adapter.SelectCommand = New MySqlCommand( _
                "select * from " & strTableName, myConnection)
            adapter.Fill(dataset, strTableName)
            myConnection.Close()
            If dataset.Tables(strTableName).Rows.Count > 0 Then
                FillTable = True
            Else
                FillTable = False
            End If
        Catch ex As MySqlException
            Debug.Print("[" & Now() & "]" & "FillTable関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        Catch ex As Exception
            Debug.Print("[" & Now() & "]" & "FillTable関数を実行中に例外発生)" & ex.Message)
        End Try
    End Function

    Public Function FillTablePartial(ByRef dataset As DataSet, _
                     ByVal strTableName As String, _
                     ByVal strItems As String, _
                     ByVal strConditions As String, _
                     ByVal myConnectionString As String) As Boolean
        Dim myConnection As New MySqlConnection(myConnectionString)
        FillTablePartial = False
        Try
            myConnection.Open()
            Dim adapter As New MySqlDataAdapter()
            adapter.SelectCommand = New MySqlCommand( _
                "select " & strItems & " from " & strTableName & " " & strConditions, myConnection)
            adapter.Fill(dataset, strTableName)
            myConnection.Close()
            If dataset.Tables(strTableName).Rows.Count > 0 Then
                FillTablePartial = True
            Else
                FillTablePartial = False
            End If
        Catch ex As MySqlException
            Debug.Print("[" & Now() & "]" & "FillTable関数を実行中に例外発生(" & ex.Number & ") " & ex.Message)
        Catch ex As Exception
            Debug.Print("[" & Now() & "]" & "FillTable関数を実行中に例外発生)" & ex.Message)
        End Try
    End Function










    ' デバッグ用
    Sub OutputLog(ByRef message As String)
#If DEBUG Then
        MsgBox(message)
#End If
        'Do Nothing

    End Sub
End Module
