﻿Imports System
Imports System.IO
Imports System.Text

Public Class FileInportForm
    Private ds As New DataSet

    Private Sub AnalyzeCsvLine(ByVal csvText As String, ByRef col As ArrayList)
        Dim comma_pos As Integer

        While csvText.Length > 0
            '先頭の空白を読み飛ばす
            csvText.Trim(" "c)
            comma_pos = csvText.IndexOf(","c)
            If comma_pos < 0 Then
                '後続にコンマがなければ
                col.Add(csvText)
                Exit Sub
            ElseIf comma_pos = 0 Then
                '先頭がコンマなら
                col.Add("")
                If csvText.Length > 0 Then
                    csvText = csvText.Substring(1)
                Else
                    Exit Sub
                End If
            Else
                '途中にコンマがあれば
                col.Add(csvText.Substring(0, comma_pos))
                csvText = csvText.Substring(comma_pos + 1)
            End If
        End While
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        '勘定科目定義ファイル(CSV形式)を読み込む
        Dim line As String
        Dim row As New ArrayList
        Dim col As New ArrayList
        Dim col_count_max As Integer
        Dim i, j As Integer
        Dim strSQL As String = ""
        Dim validLines As Integer
        'Dim col_name() As String = {"kaikei", "kanjo", "kamoku", "code", "kamokumei", "zeimutenkisaki", "CD"}
        Dim col_delimiter() As String = {"', ", "', ", "', ", "', ", "', ", "', ", "');"}

        OpenFileDialog1.Filter = "CSVファイル(*.csv)|*.csv"
        Try
            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                Using sr As StreamReader = New StreamReader(OpenFileDialog1.FileName, Encoding.GetEncoding("Shift_JIS"))
                    line = sr.ReadLine()
                    Do Until line Is Nothing
                        row.Add(line)
                        line = sr.ReadLine()
                    Loop
                End Using
            Else
                Exit Sub
            End If
        Catch ex As Exception
            MsgBox("ファイル読込み中にエラーが起きました。" & vbCrLf & ex.Message)
        End Try
        '全体を眺めて最大のカラム数を求める
        col_count_max = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            If col.Count > col_count_max Then
                col_count_max = col.Count
            End If
        Next i
        If col_count_max <> 7 Then
            MsgBox("指定されたファイルのカラム数が所定の値と異なりますので処理を中止します。")
            Exit Sub
        End If
        '有効な行数をカウントする
        validLines = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            If col.Item(0) = "1" Or col.Item(0) = "2" Or col.Item(0) = "3" Then
                validLines += 1
            End If
        Next i
        If validLines = 0 Then
            MsgBox("指定されたファイルの内容が無効なので処理を中止します。")
            Exit Sub
        End If
        If Form1.ds0.Tables("kanjokamoku").Rows.Count > 0 Then
            Dim result As DialogResult = MsgBox("既存の勘定科目定義を消去して更新します。宜しいですか？", MsgBoxStyle.OkCancel)
            If result = DialogResult.Cancel Then
                Exit Sub
            End If
        End If
        '既存のデータベース上のテーブルを消去
        strSQL = "truncate table kanjokamoku;"
        If NonQueryCommand(Form1.conStr, strSQL) = False Then
            Debug.Print("SQL: " & strSQL)
        End If
        '一行づつSQLコマンドを発行してデータベースに書き込む
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            If col.Item(0) = "1" Or col.Item(0) = "2" Or col.Item(0) = "3" Then
                If col.Count = 7 Then
                    strSQL = "insert into kanjokamoku (kaikei, kanjo, kamoku, code, kamokumei, zeimutenkisaki, CD) values("
                    For j = 0 To 6 'レコードは7項目
                        strSQL &= "'" & col.Item(j) & col_delimiter(j)
                    Next j
                    If NonQueryCommand(Form1.conStr, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                Else
                    '当該行は無視する
                End If
            End If
        Next i
        'データセットを更新
        Form1.ds0.Tables("kanjokamoku").Clear()
        If DataBaseModule.FillTable(Form1.ds0, "kanjokamoku", Form1.conStr) = False Then
            MsgBox("テーブル(kanjokamoku)が開けませんでした")
        Else
            MsgBox("勘定科目定義を更新しました")
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        '現金出納帳ファイル(CSV形式)を読み込む
        Dim line As String
        Dim row As New ArrayList
        Dim col As New ArrayList
        Dim col_count_max As Integer
        Dim i As Integer
        Dim strSQL As String = ""
        Dim validLines As Integer
        Dim str As String
        Dim strTable As String
        Dim dr() As DataRow

        OpenFileDialog1.Filter = "CSVファイル(*.csv)|*.csv"
        Try
            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                Using sr As StreamReader = New StreamReader(OpenFileDialog1.FileName, Encoding.GetEncoding("Shift_JIS"))
                    line = sr.ReadLine()
                    Do Until line Is Nothing
                        row.Add(line)
                        line = sr.ReadLine()
                    Loop
                End Using
            Else
                Exit Sub
            End If
        Catch ex As Exception
            MsgBox("ファイル読込み中にエラーが起きました。" & vbCrLf & ex.Message)
        End Try
        '全体を眺めて最大のカラム数を求める
        col_count_max = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            If col.Count > col_count_max Then
                col_count_max = col.Count
            End If
        Next i
        If col_count_max <> 7 Then
            MsgBox("指定されたファイルのカラム数が所定の値と異なりますので処理を中止します。")
            Exit Sub
        End If
        '有効な行数をカウントする
        validLines = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)

            str = col.Item(0)
            '有効な行の最初のカラムは日付なので、該当しない行は読み飛ばす
            If str.Length = 10 And str.IndexOf("/") = 4 Then
                If Form1.nendo.ToString <> str.Substring(0, 4) Then
                    MsgBox("1カラム目の内容(日付）が会計年度と異なります")
                    validLines = 0
                    Exit For
                End If
                '2カラム目は勘定科目コード
                str = col.Item(1)
                If str.Length <> 4 Then
                    MsgBox("2カラム目が勘定科目コードではありません" & str & ")")
                    validLines = 0
                    Exit For
                End If
                If str.Substring(0, 1) <> (Form1.TabControl1.SelectedIndex + 1).ToString Then
                    MsgBox("勘定科目コードが選択されている会計分類と一致しません")
                    validLines = 0
                    Exit For
                End If
                dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & str)
                If dr Is Nothing Then
                    MsgBox("未定義の勘定科目コードが含まれています")
                    validLines = 0
                    Exit For
                End If
                validLines += 1
            End If
        Next i
        If validLines = 0 Then
            MsgBox("指定されたファイルの内容が無効なので処理を中止します。")
            Exit Sub
        End If
        strTable = Form1.TableGenkin(Form1.TabControl1.SelectedIndex)

        If DataBaseModule.FillTable(ds, strTable, Form1.conFY) Then
            Dim result As DialogResult = MsgBox("既存の現金出納帳を消去して更新します。宜しいですか？", MsgBoxStyle.OkCancel)
            If result = DialogResult.OK Then
                '既存のデータベース上のテーブルを消去
                strSQL = "truncate table " & strTable & ";"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
            Else
                Exit Sub
            End If
        End If
        
        '一行づつSQLコマンドを発行してデータベースに書き込む
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            str = col.Item(0)
            '有効な行の最初のカラムは日付なので、該当しない行は読み飛ばす
            If str.Length = 10 And str.IndexOf("/") = 4 Then
                str.Replace("/", "-") 'MySQLの日付形式に修正する
                If col.Count = 7 Then
                    strSQL = "insert into " & strTable
                    strSQL += " (hizuke, code, syunyu, shisyutsu, zandaka, tekiyo) values("
                    strSQL &= "'" & str & "', " '日付
                    strSQL &= "'" & col.Item(1) & "', " '勘定科目コード
                    If col.Item(3) = "" Or col.Item(3) = "0" Then
                        strSQL &= "NULL, " '収入
                    Else
                        strSQL &= "'" & col.Item(3) & "', " '収入
                    End If

                    If col.Item(4) = "" Or col.Item(4) = "0" Then
                        strSQL &= "NULL, " '支出
                    Else
                        strSQL &= "'" & col.Item(4) & "', " '支出
                    End If

                    strSQL &= "'" & col.Item(5) & "', " '残高
                    strSQL &= "'" & col.Item(6) & "'); " '摘要
                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                End If
            End If
        Next i
        MsgBox("現金出納帳を更新しました")
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        '仕訳帳ファイル(CSV形式)を読み込む
        Dim line As String
        Dim row As New ArrayList
        Dim col As New ArrayList
        Dim col_count_max As Integer
        Dim i As Integer
        Dim strSQL As String = ""
        Dim validLines As Integer
        Dim str As String
        Dim strTable As String
        Dim dr() As DataRow

        OpenFileDialog1.Filter = "CSVファイル(*.csv)|*.csv"
        Try
            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
                Using sr As StreamReader = New StreamReader(OpenFileDialog1.FileName, Encoding.GetEncoding("Shift_JIS"))
                    line = sr.ReadLine()
                    Do Until line Is Nothing
                        row.Add(line)
                        line = sr.ReadLine()
                    Loop
                End Using
            Else
                Exit Sub
            End If
        Catch ex As Exception
            MsgBox("ファイル読込み中にエラーが起きました。" & vbCrLf & ex.Message)
        End Try
        '全体を眺めて最大のカラム数を求める
        col_count_max = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            If col.Count > col_count_max Then
                col_count_max = col.Count
            End If
        Next i
        If col_count_max <> 9 Then
            MsgBox("指定されたファイルのカラム数が所定の値と異なりますので処理を中止します。")
            Exit Sub
        End If
        '有効な行数をカウントする
        validLines = 0
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)

            str = col.Item(1)
            '有効な行の二番目のカラムは日付なので、該当しない行は読み飛ばす
            If str.Length = 10 And str.IndexOf("/") = 4 Then
                If Form1.nendo.ToString <> str.Substring(0, 4) Then
                    MsgBox("1カラム目の内容(日付）が会計年度と異なります")
                    validLines = 0
                    Exit For
                End If
                '3カラム目は勘定科目コード
                str = col.Item(2)
                If str.Length <> 4 Then
                    MsgBox("3カラム目が勘定科目コードではありません(" & str & ")")
                    validLines = 0
                    Exit For
                End If
                If str.Substring(0, 1) <> (Form1.TabControl1.SelectedIndex + 1).ToString Then
                    MsgBox("勘定科目コードが選択されている会計分類と一致しません")
                    validLines = 0
                    Exit For
                End If
                dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & str)
                If dr Is Nothing Then
                    MsgBox("未定義の勘定科目コードが含まれています")
                    validLines = 0
                    Exit For
                End If
                '6カラム目は勘定科目コード
                str = col.Item(5)
                If str.Length <> 4 Then
                    MsgBox("6カラム目が勘定科目コードではありません(" & str & ")")
                    validLines = 0
                    Exit For
                End If
                If str.Substring(0, 1) <> (Form1.TabControl1.SelectedIndex + 1).ToString Then
                    MsgBox("勘定科目コードが選択されている会計分類と一致しません")
                    validLines = 0
                    Exit For
                End If
                dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & str)
                If dr Is Nothing Then
                    MsgBox("未定義の勘定科目コードが含まれています")
                    validLines = 0
                    Exit For
                End If
                validLines += 1
            End If
        Next i
        If validLines = 0 Then
            MsgBox("指定されたファイルの内容が無効なので処理を中止します。")
            Exit Sub
        End If
        strTable = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)

        If DataBaseModule.FillTable(ds, strTable, Form1.conFY) Then
            Dim result As DialogResult = MsgBox("既存の仕訳帳を消去して更新します。宜しいですか？", MsgBoxStyle.OkCancel)
            If result = DialogResult.OK Then
                '既存のデータベース上のテーブルを消去
                strSQL = "truncate table " & strTable & ";"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
            Else
                Exit Sub
            End If
        End If

        '一行づつSQLコマンドを発行してデータベースに書き込む
        For i = 0 To row.Count - 1
            col.Clear()
            AnalyzeCsvLine(row.Item(i), col)
            str = col.Item(1)
            '有効な行の二番目のカラムは日付なので、該当しない行は読み飛ばす
            If str.Length = 10 And str.IndexOf("/") = 4 Then
                str.Replace("/", "-") 'MySQLの日付形式に修正する
                If col.Count = 9 Then
                    strSQL = "insert into " & strTable
                    strSQL &= " (yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks) values("
                    strSQL &= "'" & str & "', " '日付
                    strSQL &= "'" & col.Item(2) & "', " '借方勘定科目コード
                    '借方勘定科目はデータベースに書かない
                    strSQL &= "'" & col.Item(4) & "', " '借方金額
                    strSQL &= "'" & col.Item(5) & "', " '貸方勘定科目コード
                    '貸方勘定科目はデータベースに書かない
                    strSQL &= "'" & col.Item(7) & "', " '貸方金額
                    strSQL &= "'" & col.Item(8) & "'); " '摘要
                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                    Debug.Print("SQL: " & strSQL)
                End If
            End If
        Next i
        MsgBox("仕訳帳を更新しました")
    End Sub
End Class