﻿Public Class FileOutForm
    Private ds As New DataSet

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        SaveFileDialog1.FileName = ""
        SaveFileDialog1.Filter = "CSV files (*.csv)|*.csv|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            'TextBox1.Text = SaveFileDialog1.FileName
            'Me.ActiveControl = Me.Button2
            FileOutput(SaveFileDialog1.FileName)
            Me.Close()
        End If
    End Sub

    Private Sub FileOutput(ByVal filename As String)
        Dim strTable As String
        Dim ChoboEnum As Integer
        Dim rows As Integer
        Dim i As Integer
        Dim strLine As String = ""
        Dim dt As New DataTable
        Dim dr() As DataRow
        Dim kamokuCode As String = ""
        Dim syunyu As Integer
        Dim shisyutsu As Integer
        Dim DrCode As String = ""
        Dim CrCode As String = ""
        Dim kamoku As String = ""
        Dim tekiyo As String = ""
        Dim zandaka As Integer = 0
        Dim PrevKamoku As String = ""
        Dim DrAmount As Integer
        Dim CrAmount As Integer
        Dim taisyaku As String = ""
        Dim columns As String = ""
        Dim strItems As String = "*"
        Dim strConditions As String = ""
        'Dim kaikeikubun() As String = {"農業", "事業", "家計"}
        Dim title As String = ""

        dt = Form1.ds0.Tables("kanjokamoku")

        'テーブル名をラジオボタンから判別する
        If RbGenkin.Checked Then
            strTable = Form1.TableGenkin(Form1.TabControl1.SelectedIndex)
            ChoboEnum = 1
            'データセットにテーブルを読み込む
            ds.Clear()
            strConditions = "order by hizuke, id"
            If DataBaseModule.FillTablePartial(ds, strTable, strItems, strConditions, Form1.conFY) = False Then
                'テーブルの行数がゼロならメッセージボックスに表示して中止する
                MsgBox("テーブル(" & strTable & ")の行数がゼロでしたので処理を中止します")
                Exit Sub
            End If
            title = Form1.LbNendo.Text & "," & Form1.kaikeikubun(Form1.TabControl1.SelectedIndex) & ",現金出納帳"
            columns = "日付, 勘定＃, 勘定科目, 収入,  支出, 残高, 摘要"

        ElseIf RbShiwake.Checked Then
            strTable = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)
            ChoboEnum = 2
            'データセットにテーブルを読み込む
            ds.Clear()
            strConditions = "order by yyyymmdd, id"
            If DataBaseModule.FillTablePartial(ds, strTable, strItems, strConditions, Form1.conFY) = False Then
                'テーブルの行数がゼロならメッセージボックスに表示して中止する
                MsgBox("テーブル(" & strTable & ")の行数がゼロでしたので処理を中止します")
                Exit Sub
            End If
            title = ",," & Form1.LbNendo.Text & "," & Form1.kaikeikubun(Form1.TabControl1.SelectedIndex) & ",仕訳帳"
            columns = "仕丁, 日付, 借方＃, 借方勘定科目,  借方金額, 貸方＃, 貸方勘定科目, 貸方金額, 摘要"
        Else
            strTable = Form1.TableMotocho(Form1.TabControl1.SelectedIndex)
            ChoboEnum = 3
            'データセットにテーブルをkamoku順に読み込む
            ds.Clear()
            strConditions = "order by kamoku, yyyymmdd, id"
            If DataBaseModule.FillTablePartial(ds, strTable, strItems, strConditions, Form1.conFY) = False Then
                'テーブルの行数がゼロならメッセージボックスに表示して中止する
                MsgBox("テーブル(" & strTable & ")の行数がゼロでしたので処理を中止します")
                Exit Sub
            End If
            kamoku = ds.Tables(strTable).Rows(0).Item("kamoku").ToString
            PrevKamoku = kamoku
            title = ",," & Form1.LbNendo.Text & "," & Form1.kaikeikubun(Form1.TabControl1.SelectedIndex) & ",総勘定元帳" & vbCrLf & vbCrLf
            columns = "勘定＃, 勘定, 日付, 摘要＃, 摘要,  仕丁, 借方金額, 貸方金額, 貸借, 残高"
        End If

        'ファイルをオープンする
        Dim textFile As System.IO.StreamWriter
        textFile = New System.IO.StreamWriter(filename, False, System.Text.Encoding.GetEncoding("shift_jis"))
        textFile.WriteLine(title)   '最初の行にタイトルを書き出す
        textFile.WriteLine(columns) '次にカラム名を書き出す

        'テーブルの行数だけファイルに書き出す
        rows = ds.Tables(strTable).Rows.Count
        zandaka = 0 '現金出納帳の残高はテーブルの値を用いず、収入と支出から累計する
        For i = 0 To rows - 1
            '以降の処理は対象とする帳簿により異なるのでselectで分岐する
            Select Case ChoboEnum
                Case 1 '現金出納簿

                    kamokuCode = ds.Tables(strTable).Rows(i).Item("code").ToString
                    If Not IsDBNull(ds.Tables(strTable).Rows(i).Item("syunyu")) Then
                        syunyu = ds.Tables(strTable).Rows(i).Item("syunyu")
                        zandaka += syunyu
                    End If
                    If Not IsDBNull(ds.Tables(strTable).Rows(i).Item("shisyutsu")) Then
                        shisyutsu = ds.Tables(strTable).Rows(i).Item("shisyutsu")
                        zandaka -= shisyutsu
                    End If
                    strLine = ds.Tables(strTable).Rows(i).Item("hizuke") & ","
                    strLine &= kamokuCode & ","
                    dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & kamokuCode)
                    strLine &= dr(0).Item("kamokumei") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("syunyu") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("shisyutsu") & ","
                    strLine &= zandaka.ToString & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("tekiyo")

                Case 2 '仕訳帳
                    DrCode = ds.Tables(strTable).Rows(i).Item("DrCode").ToString
                    CrCode = ds.Tables(strTable).Rows(i).Item("CrCode").ToString

                    strLine = ds.Tables(strTable).Rows(i).Item("id") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("yyyymmdd") & ","
                    strLine &= DrCode & ","
                    dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & DrCode)
                    strLine &= dr(0).Item("kamokumei") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("DrAmount") & ","
                    strLine &= CrCode & ","
                    dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & CrCode)
                    strLine &= dr(0).Item("kamokumei") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("CrAmount") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("remarks")

                Case 3 '総勘定元帳
                    kamoku = ds.Tables(strTable).Rows(i).Item("kamoku").ToString
                    tekiyo = ds.Tables(strTable).Rows(i).Item("tekiyo").ToString

                    If kamoku <> PrevKamoku Then
                        '勘定科目が変わったのでマーカーを挿入し、残高をクリアする
                        textFile.WriteLine(" ") '空行
                        textFile.WriteLine(" ") '空行
                        textFile.WriteLine(columns)
                        PrevKamoku = kamoku
                        zandaka = 0
                    End If
                    If IsDBNull(ds.Tables(strTable).Rows(i).Item("DrAmount")) Then
                        DrAmount = 0
                    Else
                        DrAmount = ds.Tables(strTable).Rows(i).Item("DrAmount")
                    End If
                    If IsDBNull(ds.Tables(strTable).Rows(i).Item("CrAmount")) Then
                        CrAmount = 0
                    Else
                        CrAmount = ds.Tables(strTable).Rows(i).Item("CrAmount")
                    End If
                    zandaka = zandaka + DrAmount - CrAmount
                    If zandaka >= 0 Then
                        taisyaku = "借"
                    Else
                        taisyaku = "貸"
                    End If
                    strLine = kamoku & ","
                    dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & kamoku)
                    strLine &= dr(0).Item("kamokumei") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("yyyymmdd") & ","
                    strLine &= tekiyo & ","
                    dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & tekiyo)
                    strLine &= dr(0).Item("kamokumei") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("id") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("DrAmount") & ","
                    strLine &= ds.Tables(strTable).Rows(i).Item("CrAmount") & ","
                    strLine &= taisyaku & ","
                    strLine &= System.Math.Abs(zandaka).ToString

            End Select
            textFile.WriteLine(strLine)
        Next
        textFile.Close()
        '何行分のデータを書いたのかをメッセージボックスに表示して終了する
        MsgBox(i.ToString & "行分のデータを書き出しました")
    End Sub

End Class