﻿'title:                 kaikei3
'author:                H.NAMVA
'description            農業、事業および家計の３つをカバーする複式簿記
'original issued on:    2014.02.05  version 1.0
'last updated on:       xxxx.xx.xx  version x.x

Imports MySql.Data.MySqlClient
Imports System.Math
Imports System
Imports System.IO
Imports System.Text

Public Class Form1
    Private Const InitFileName = "\kaikei3.ini"
    Public conStr As String = ""
    Public conFY As String = ""
    Public conDB As New MySqlConnection
    Private MyCommand As MySqlCommand
    Private ds As New DataSet 'for database: FY????
    Public ds0 As New DataSet 'for database: kaikei3
    Public KamokuCode As String
    Public nendo As Integer        '会計年度
    Public Structure inpDataT
        Dim dateStrGenkin As String
        Dim syushi As Integer       '現金出納の(＋なら)収入または（－なら）支出
        Dim zandaka As Integer      '現金残高
        Dim wrote As Boolean
    End Structure
    Public inpData As inpDataT

    Public Structure shiwakeT
        Dim dateStrShiwake As String
        Dim gyosu As Integer
        Dim wrote As Boolean
    End Structure
    Public shiwakeData As shiwakeT
    Public kaikeikubun() As String = {"農業", "事業", "家計"}
    Private sUSER As String = ""
    Private sPASS As String = ""
    Private sSERVER As String = ""


    Public Sub GamenShokika()
        Dim i As Integer
        Dim zandaka As Integer = 0

        TabControl1.SelectedIndex = 0
        Dim strTable As String = TableGenkin(TabControl1.SelectedIndex)
        Dim tablesCol As DataTableCollection = ds.Tables
        If tablesCol.Contains(strTable) Then
            ds.Tables(strTable).Clear()
        End If
        If DataBaseModule.FillTable(ds, strTable, conFY) = False Then
            '現金出納帳のデータが無い場合、残高は0円
            lblZandaka.Text = "\0"
        Else
            Dim rows As Integer = ds.Tables(strTable).Rows.Count
            For i = 0 To rows - 1
                If Not IsDBNull(ds.Tables(strTable).Rows(i).Item("syunyu")) Then
                    zandaka += ds.Tables(strTable).Rows(i).Item("syunyu")
                ElseIf Not IsDBNull(ds.Tables(strTable).Rows(i).Item("shisyutsu")) Then
                    zandaka -= ds.Tables(strTable).Rows(i).Item("shisyutsu")
                End If
            Next i
            inpData.zandaka = zandaka
            lblZandaka.Text = zandaka.ToString("C")
        End If
        Me.ActiveControl = Me.TextBox1
        shiwakeGamenClear()
        shiwakeData.gyosu = 1
    End Sub

    Public Function ReadCommonTable() As Boolean
        ReadCommonTable = False
        If DataBaseModule.FillTable(ds0, "kanjokamoku", conStr) = False Then
            Debug.Print("conStr = " & conStr)
            MsgBox("テーブル(kanjokamoku)が開けませんでした")
            ds0.Dispose()
            Exit Function
        End If
        If DataBaseModule.FillTable(ds0, "kaikeinendo", conStr) = False Then
            Dim result As DialogResult = MsgBox("テーブル(kaikeinendo)が開けませんでした" & _
                                                "初めてkaikei3を起動しましたか？", MsgBoxStyle.YesNo)
            If result = DialogResult.Yes Then
                '新規作成と同じ処理をする
                Form2.ShowDialog()
                If DataBaseModule.FillTable(ds0, "kaikeinendo", conStr) = False Then
                    MsgBox("再びテーブル(kaikeinedo)開けませんでした")
                    ds0.Dispose()
                    Exit Function
                End If
            Else
                ds0.Dispose()
                Exit Function
            End If
        End If
        If DataBaseModule.FillTable(ds0, "lastused", conStr) = False Then
            MsgBox("テーブル(lastused)が開けませんでした")
            ds0.Dispose()
            Exit Function
        End If
        ReadCommonTable = True
    End Function

    Public Sub makeConFY(ByVal dbName As String)
        conFY = "Database=" & dbName & _
                " ;User ID=" & sUSER & " ;Password=" & sPASS & " ;Data Source=" & sSERVER
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sr As System.IO.StreamReader = Nothing
        Dim buf As String = ""
        Dim ExeFileLocation As String

        Debug.Print("program started: " & Now)

        Try
            ExeFileLocation = System.IO.Path.GetDirectoryName( _
                                 System.Reflection.Assembly.GetExecutingAssembly().Location)
            sr = New System.IO.StreamReader(ExeFileLocation & InitFileName)
            Do
                buf = sr.ReadLine()
                If IsNothing(buf) Then
                    Exit Do
                End If
                Select Case buf.Substring(0, InStr(buf, ":") - 1)
                    Case "[USER]"
                        sUSER = Mid(buf, InStr(buf, ":") + 1)
                    Case "[PASS]"
                        sPASS = Mid(buf, InStr(buf, ":") + 1)
                    Case "[SERVER]"
                        sSERVER = Mid(buf, InStr(buf, ":") + 1)
                End Select
            Loop
            sr.Close()
            conStr = "Database=kaikei3" & ";User ID=" & sUSER _
                        & ";Password=" & sPASS & ";Data Source=" & sSERVER
            'Debug.Print("conStr=" & conStr)
        Catch ex As Exception
            MsgBox("INIファイル(kaikei3.ini)が見当たりません")
            Me.Close()
        End Try

        If ReadCommonTable() = False Then
            Me.Close()
            Exit Sub
        End If
        makeConFY(ds0.Tables("lastused").Rows(0).Item("nameDB"))
        'Debug.Print("conFY =" & conFY)
        nendo = ds0.Tables("lastused").Rows(0).Item("nendo")
        LbNendo.Text = nendo.ToString & "年度"
        GamenShokika()
    End Sub

    Sub FillLbKamoku(ByRef dr() As DataRow)
        Dim i As Integer

        ListBox1.Items.Clear()
        For i = 0 To dr.Count - 1
            ListBox1.Items.Add(dr(i).Item("code") & " " & dr(i).Item("CD") & " " & dr(i).Item("kamokumei"))
        Next
    End Sub

    Private Sub showKamoku(ByRef textbox As TextBox)
        Dim strWhere As String = ""
        If textbox.Text.Length = 0 Then
            strWhere = "kaikei='" & (TabControl1.SelectedIndex + 1).ToString & "'"
        ElseIf textbox.Text.Length = 1 Then
            strWhere = "kaikei='" & textbox.Text & "'"
        ElseIf (textbox.Text.Length = 2) Or (textbox.Text.Length = 3) Then
            strWhere = "kaikei='" & textbox.Text.Substring(0, 1) & _
                "' and kanjo='" & textbox.Text.Substring(1, 1) & "'"
        ElseIf textbox.Text.Length = 4 Then
            strWhere = "code='" & textbox.Text & "'"
        End If
        Dim dr() As DataRow
        dr = ds0.Tables("kanjokamoku").Select(strWhere)
        FillLbKamoku(dr)
    End Sub

    Function kamokuInitialCheck(ByVal kaikei As String) As Boolean
        Dim kaikeiInt As Integer = CInt(kaikei)
        If kaikei = "0" Then
            kamokuInitialCheck = True
            Exit Function
        End If

        If TabControl1.SelectedIndex + 1 = kaikeiInt Then
            kamokuInitialCheck = True
        Else
            kamokuInitialCheck = False
        End If
    End Function

    Function kamokuCheck(ByVal strCode As String) As Boolean
        kamokuCheck = False
        If kamokuInitialCheck(strCode.Substring(0, 1)) = False Then
            MsgBox("勘定科目コードが選択されているタブと不一致です")
            Exit Function
        End If
        Dim dr() As DataRow
        dr = ds0.Tables("kanjokamoku").Select("code = " & "'" & strCode & "'")
        If dr.Count > 0 Then
            kamokuCheck = True
        Else
            MsgBox("不正な勘定科目コードです")
        End If
    End Function

    Public Function isValidAsInteger(ByVal strInteger As String) As Integer
        isValidAsInteger = 0

        Dim strRep As String = ""
        Try
            If strInteger.Length = 0 Then
                Exit Function
            End If

            Dim index As Integer = strInteger.IndexOf(Chr(92).ToString)
            If index < 0 Then
                strRep = strInteger
            Else
                strRep = strInteger.Substring(index + 1)
            End If
            strRep = strRep.Replace(",", "")
            Dim intVal As Integer = Integer.Parse(strRep)
            If intVal >= 0 Then
                isValidAsInteger = intVal
            Else
                isValidAsInteger = -1
                MsgBox("正整数を入力してください")
            End If

        Catch ex As Exception
            isValidAsInteger = -2
            MsgBox("整数として適切な値を入力してください" & strRep)
        End Try
    End Function

    Private Sub kamokuDainyu(ByRef TxbCode As TextBox, ByRef TxbName As TextBox)
        If TxbCode.Text.Length <> 4 Then
            If MsgBox("勘定科目が未入力です", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
                Exit Sub
            Else
                Me.ActiveControl = TxbCode
            End If
        End If
        If kamokuCheck(TxbCode.Text) Then
            Dim dr() As DataRow
            dr = ds0.Tables("kanjokamoku").Select("code = " & "'" & TxbCode.Text & "'")
            TxbName.Text = dr(0).Item("kamokumei")
        Else
            Me.ActiveControl = TxbCode
        End If
    End Sub

    Private Sub TextBox2_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.Enter
        showKamoku(TextBox2)
    End Sub

    Private Sub TextBox2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.TextChanged
        showKamoku(TextBox2)
    End Sub

    Private Sub TextBox2_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        inpData.wrote = False
        kamokuDainyu(TextBox2, TextBox3)
    End Sub

    Sub genkinGamenClear()
        TextBox1.Text = ""
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        TextBox6.Text = ""
        Me.ActiveControl = Me.TextBox1
    End Sub

    Private Sub BtnGenkinClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnGenkinClear.Click
        If inpData.wrote = False Then
            If MsgBox("まだ記帳されていませんが、本当にクリアしますか？", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
                genkinGamenClear()
            End If
        Else
            genkinGamenClear()
        End If
    End Sub

    Private Sub BtnGenkinKicho_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnGenkinKicho.Click
        '決算処理により帳簿類の書き込みが禁止されているかをチェック
        Dim strKessanDate As String = ""
        If SeisanForm.GetKessanDate(nendo, strKessanDate) = False Then
            MsgBox("決算日の取得に失敗しました")
            Exit Sub
        End If
        If strKessanDate <> "NULL" Then
            MsgBox("既に決算処理により帳簿類が締め切られています　" &
                   strKessanDate)
            Exit Sub
        End If

        '有効な日付かどうかをチェック
        If hizukeCheck(TextBox1.Text, inpData.dateStrGenkin) = False Then
            Me.ActiveControl = Me.TextBox1
            Exit Sub
        End If
        '有効な勘定科目コードかどうかをチェック
        If kamokuCheck(TextBox2.Text) = False Then
            Me.ActiveControl = Me.TextBox2
            Exit Sub
        End If
        '収入が整数として有効な値かをチェック（ただしブランクはOK）
        Dim syunyu = isValidAsInteger(TextBox4.Text)
        inpData.syushi = 0
        If syunyu > 0 Then
            inpData.syushi = syunyu
        ElseIf syunyu < 0 Then
            Me.ActiveControl = Me.TextBox4
            Exit Sub
        End If
        '支出が整数として有効な値かをチェック（ただしブランクはOK）
        Dim shisyutsu = isValidAsInteger(TextBox5.Text)
        If shisyutsu > 0 Then
            inpData.syushi = -1 * shisyutsu
        ElseIf shisyutsu < 0 Then
            Me.ActiveControl = Me.TextBox5
            Exit Sub
        End If
        '収入と支出の両方がブランクは不可
        If TextBox4.Text.Length = 0 And TextBox5.Text.Length = 0 Then
            MsgBox("収入と支出の両方がブランクです")
            Me.ActiveControl = Me.TextBox4
            Exit Sub
        End If
        '収入と支出のいずれか一方はブランクであること
        If TextBox4.Text.Length <> 0 And TextBox5.Text.Length <> 0 Then
            MsgBox("収入と支出の両方に数値があります")
            Me.ActiveControl = Me.TextBox5
            Exit Sub
        End If
        '摘要の文字数が2文字以上であること
        If TextBox6.Text.Length < 2 Then
            If MsgBox("摘要欄が空白です", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
                Me.ActiveControl = Me.TextBox6
            End If
            Exit Sub
        End If

        '選択されているTabコントロールによりデータベース(genkin1, genkin2, genkin3)のいずれかに記録する
        Dim strTable As String = TableGenkin(TabControl1.SelectedIndex)
        Dim strSQL As String = "insert into " & strTable & "(hizuke, code, syunyu, shisyutsu, zandaka, tekiyo)" _
                               & " values('" & inpData.dateStrGenkin & "', '" _
                               & TextBox2.Text & "', "
        If TextBox4.Text.Length = 0 Then
            strSQL &= "null, " & "'" & Abs(inpData.syushi).ToString & "', '"
        Else
            strSQL &= "'" & Abs(inpData.syushi).ToString & "', null, '"
        End If
        '残高を更新する
        inpData.zandaka += inpData.syushi
        lblZandaka.Text = inpData.zandaka.ToString("C")
        strSQL &= inpData.zandaka.ToString & "', '" & TextBox6.Text & "');"
        If NonQueryCommand(conFY, strSQL) = False Then
            Debug.Print("SQL: " & strSQL)
        End If
        '仕訳画面に転記する
        TbDate.Text = TextBox1.Text '日付
        TbRemarks.Text = TextBox6.Text '摘要
        If inpData.syushi > 0 Then
            '収支が＋なら現金は借方、相手は貸方
            TbA0.Text = kamokuCodeGenkin(TabControl1.SelectedIndex)
            TbB0.Text = "現金"
            TbC0.Text = TextBox4.Text
            TbD0.Text = TextBox2.Text
            TbE0.Text = TextBox3.Text
            TbF0.Text = TextBox4.Text
        Else
            '収支が－なら現金は貸方、相手は借方
            TbA0.Text = TextBox2.Text
            TbB0.Text = TextBox3.Text
            TbC0.Text = TextBox5.Text
            TbD0.Text = kamokuCodeGenkin(TabControl1.SelectedIndex)
            TbE0.Text = "現金"
            TbF0.Text = TextBox5.Text
        End If
        '入力されたテキストボックスをクリアする
        'TextBox1.Text = ""
        TextBox2.Text = ""
        TextBox3.Text = ""
        TextBox4.Text = ""
        TextBox5.Text = ""
        TextBox6.Text = ""
        ListBox1.Items.Clear()

        'タブコントロールを仕訳画面の記帳ボタンに移動させる
        Me.ActiveControl = Me.BtnShiwakeKicho
        inpData.wrote = True
    End Sub

    Private Function hizukeCheck(ByVal strMM_DD As String, ByRef strYYYY_MM_DD As String) As Boolean
        hizukeCheck = False
        Dim hizuke As DateTime
        Try
            hizuke = DateTime.Parse(nendo.ToString & "/" & strMM_DD)
            strYYYY_MM_DD = hizuke.ToString("yyyy-MM-dd")
            hizukeCheck = True
        Catch ex As Exception
            MsgBox("日付が不正です")
            strYYYY_MM_DD = ""
        End Try
    End Function

    Private Sub TextBox1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        Select Case e.KeyCode
            Case Keys.Down
                Me.ActiveControl = Me.TbDate
        End Select
    End Sub

    Private Sub TextBox1_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        If TextBox1.Text.Length = 0 Then
            Me.ActiveControl = Me.TbDate
            Exit Sub 'ignore this event
        End If
        inpData.wrote = False
        If hizukeCheck(TextBox1.Text, inpData.dateStrGenkin) = False Then
            Me.ActiveControl = Me.TextBox1
        End If
    End Sub

    Function TableGenkin(ByVal index As Integer) As String
        TableGenkin = ""
        Select Case index
            Case 0
                TableGenkin = "genkin1"
            Case 1
                TableGenkin = "genkin2"
            Case 2
                TableGenkin = "genkin3"
        End Select
    End Function

    Function kamokuCodeGenkin(ByVal index As Integer) As String
        kamokuCodeGenkin = ""
        Select Case index
            Case 0
                kamokuCodeGenkin = "1101"
            Case 1
                kamokuCodeGenkin = "2101"
            Case 2
                kamokuCodeGenkin = "3101"
        End Select
    End Function

    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        '新たに選択されたTabコントロールに相当するgenkinデータベースを参照して残高を表示する
        Dim zandaka As Integer = 0
        Dim strTable As String = TableGenkin(TabControl1.SelectedIndex)
        Dim tablesCol As DataTableCollection = ds.Tables
        If tablesCol.Contains(strTable) Then
            ds.Tables(strTable).Clear()
        End If
        If DataBaseModule.FillTable(ds, strTable, conFY) = False Then
            inpData.zandaka = 0
            lblZandaka.Text = "\0"
        Else
            Dim rows As Integer = ds.Tables(strTable).Rows.Count
            For i = 0 To rows - 1
                If Not IsDBNull(ds.Tables(strTable).Rows(i).Item("syunyu")) Then
                    zandaka += ds.Tables(strTable).Rows(i).Item("syunyu")
                ElseIf Not IsDBNull(ds.Tables(strTable).Rows(i).Item("shisyutsu")) Then
                    zandaka -= ds.Tables(strTable).Rows(i).Item("shisyutsu")
                End If
            Next i
            inpData.zandaka = zandaka
            lblZandaka.Text = zandaka.ToString("C")
        End If
    End Sub

    Private Sub ToCurrency(ByRef textbox As TextBox)
        If textbox.Text.Length > 0 Then
            Dim atai = isValidAsInteger(textbox.Text)
            If atai >= 0 Then
                textbox.Text = atai.ToString("C")
            End If
        End If
    End Sub

    Private Sub TextBox4_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox4.Leave
        ToCurrency(TextBox4)
    End Sub

    Private Sub TextBox5_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox5.Leave
        ToCurrency(TextBox5)
    End Sub

    Public Sub shiwakeGamenClear()
        TbDate.Text = ""
        TbA0.Text = ""
        TbB0.Text = ""
        TbC0.Text = ""
        TbD0.Text = ""
        TbE0.Text = ""
        TbF0.Text = ""
        TbRemarks.Text = ""
    End Sub

    Private Sub BtnSihiwakeClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnShiwakeClear.Click
        shiwakeGamenClear()
    End Sub

    Function TableShiwake(ByVal index As Integer) As String
        TableShiwake = ""
        Select Case index
            Case 0
                TableShiwake = "shiwake1"
            Case 1
                TableShiwake = "shiwake2"
            Case 2
                TableShiwake = "shiwake3"
        End Select
    End Function

    Private Sub BtnShiwakeKicho_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnShiwakeKicho.Click
        '決算処理により帳簿類の書き込みが禁止されているかをチェック
        Dim strKessanDate As String = ""
        If SeisanForm.GetKessanDate(nendo, strKessanDate) = False Then
            MsgBox("決算日の取得に失敗しました")
            Exit Sub
        End If
        If strKessanDate <> "NULL" Then
            MsgBox("既に決算処理により帳簿類が締め切られています　" &
                   strKessanDate)
            Exit Sub
        End If

        '有効な日付かどうかをチェック
        If hizukeCheck(TbDate.Text, shiwakeData.dateStrShiwake) = False Then
            Me.ActiveControl = Me.TbDate
            Exit Sub
        End If
        '借方勘定科目コードが有効かをチェック
        If kamokuCheck(TbA0.Text) = False Then
            Me.ActiveControl = Me.TbA0
            Exit Sub
        End If
        '貸方勘定科目コードが有効かをチェック
        If kamokuCheck(TbD0.Text) = False Then
            Me.ActiveControl = Me.TbD0
            Exit Sub
        End If

        '貸方金額が整数として有効かをチェック（ブランクはダメ）
        Dim amount As Integer = isValidAsInteger(TbC0.Text)
        If amount < 0 Then 'ブランクの時はゼロになる
            Me.ActiveControl = Me.TbA0
            Exit Sub
        End If
        '摘要の文字数が2文字以上であること
        If TbRemarks.Text.Length < 2 Then
            If MsgBox("摘要欄が空白です", MsgBoxStyle.OkCancel) = MsgBoxResult.Ok Then
                Me.ActiveControl = Me.TbRemarks
            End If
            Exit Sub
        End If

        '選択されているTabコントロールによりデータベース(shiwake1, shiwake2, shiwake3)のいずれかに記録する
        Dim strTable As String = TableShiwake(TabControl1.SelectedIndex)
        Dim strSQL As String = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                               & " values('" & shiwakeData.dateStrShiwake & "', '" _
                               & TbA0.Text & "', '" & amount.ToString & "', '" _
                               & TbD0.Text & "', '" & amount.ToString & "', '" _
                               & TbRemarks.Text & "');"
        If NonQueryCommand(conFY, strSQL) = False Then
            Debug.Print("SQL: " & strSQL)
        End If
        '日付を残しその他の仕訳画面をクリアする
        Dim strDate As String = TbDate.Text
        shiwakeGamenClear()
        TbDate.Text = strDate
        'タブコントロールを日付入力に移動させる
        Me.ActiveControl = Me.TbDate
        shiwakeData.wrote = True
    End Sub

    Private Sub TbDate_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TbDate.KeyDown
        Select Case e.KeyCode
            Case Keys.Up
                Me.ActiveControl = Me.TextBox1
        End Select
    End Sub

    Private Sub TbA0_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TbA0.TextChanged
        showKamoku(TbA0)
    End Sub

    Private Sub TbA0_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TbA0.Leave
        kamokuDainyu(TbA0, TbB0)
    End Sub

    Private Sub TbC0_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TbC0.Leave
        ToCurrency(TbC0)
        TbF0.Text = TbC0.Text
    End Sub

    Private Sub TbD0_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TbD0.TextChanged
        showKamoku(TbD0)
    End Sub


    Private Sub TbD0_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TbD0.Leave
        kamokuDainyu(TbD0, TbE0)
    End Sub

    Private Sub データベースDToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles データベースDToolStripMenuItem.Click
        Form2.ShowDialog()
    End Sub

    Private Sub 開くOToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 開くOToolStripMenuItem.Click
        Form3.ShowDialog()
    End Sub

    Function TableMotocho(ByVal index As Integer) As String
        TableMotocho = ""
        Select Case index
            Case 0
                TableMotocho = "motocho1"
            Case 1
                TableMotocho = "motocho2"
            Case 2
                TableMotocho = "motocho3"
        End Select
    End Function

    Private Sub 総勘定元帳へ転記ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 総勘定元帳へ転記ToolStripMenuItem.Click
        Try
            '選択されているTabコントロールにより仕訳帳と総勘定元帳のテーブル名を得る
            Dim strShiwake As String = TableShiwake(TabControl1.SelectedIndex)
            Dim strMotocho As String = TableMotocho(TabControl1.SelectedIndex)
            ds.Clear()
            'テーブルに仕訳帳のデータを読込む
            If DataBaseModule.FillTable(ds, strShiwake, conFY) = False Then
                Debug.Print("conFY= " & conFY)
                MsgBox("テーブル(" & strShiwake & ")が開けませんでした")
                Exit Sub
            End If
            Dim rows As Integer = ds.Tables(strShiwake).Rows.Count
            '総勘定元帳のテーブルを空にする
            Dim strSQL As String = "truncate table " & strMotocho & ";"
            If NonQueryCommand(conFY, strSQL) = False Then
                Debug.Print("SQL: " & strSQL)
            End If
            '仕訳帳のレコードを順に転記する
            Dim i As Integer
            Dim id As Integer
            Dim yyyymmdd As Date
            Dim DrCode As String
            Dim DrAmount As Integer
            Dim CrCode As String
            Dim CrAmount As Integer

            For i = 0 To rows - 1
                id = ds.Tables(strShiwake).Rows(i).Item("id")
                yyyymmdd = ds.Tables(strShiwake).Rows(i).Item("yyyymmdd")
                DrCode = ds.Tables(strShiwake).Rows(i).Item("DrCode")
                DrAmount = ds.Tables(strShiwake).Rows(i).Item("DrAmount")
                CrCode = ds.Tables(strShiwake).Rows(i).Item("CrCode")
                CrAmount = ds.Tables(strShiwake).Rows(i).Item("CrAmount")
                '借方の転記
                strSQL = "insert into " & strMotocho & "(kamoku, yyyymmdd, " & _
                    "tekiyo, id, DrAmount, CrAmount, DorC, zandaka) "
                strSQL &= "values (" & DrCode & ", '" & yyyymmdd.ToString("yyyy-MM-dd") & _
                    "', " & CrCode & ", " & id.ToString & ", "
                strSQL &= DrAmount.ToString & ", NULL, '-', 0);"
                If NonQueryCommand(conFY, strSQL) = False Then
                    Debug.Print("motochoDr SQL: " & strSQL)
                End If
                '貸方の転記
                strSQL = "insert into " & strMotocho & "(kamoku, yyyymmdd, " & _
                    "tekiyo, id, DrAmount, CrAmount, DorC, zandaka) "
                strSQL &= "values (" & CrCode & ", '" & yyyymmdd.ToString("yyyy-MM-dd") & "', " & DrCode & _
                    ", " & id.ToString & ", "
                strSQL &= "NULL, " & CrAmount.ToString & ", '-', 0);"
                If NonQueryCommand(conFY, strSQL) = False Then
                    Debug.Print("motochoCr SQL: " & strSQL)
                End If
            Next
            '最後に終了した旨のメッセージを表示する
            MsgBox("仕訳帳から総勘定元帳へ転記が終了しました （" & rows.ToString & "件）")

        Catch ex As Exception
            MsgBox(ex.Message)
            Debug.Print("Form1.総勘定元帳へ転記")
        End Try

    End Sub

    Private Sub ファイルに出力PToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ファイルに出力PToolStripMenuItem.Click
        FileOutForm.ShowDialog()
    End Sub

    Private Sub 精算表の表示SToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 精算表の表示SToolStripMenuItem.Click
        SeisanForm.Show()
    End Sub

    Private Sub 決算処理の取消DToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 決算処理の取消DToolStripMenuItem.Click
        '決算処理により帳簿類の書き込みが禁止されているかをチェック
        Dim strKessanDate As String = ""
        If SeisanForm.GetKessanDate(nendo, strKessanDate) = False Then
            MsgBox("決算日の取得に失敗しました")
            Exit Sub
        End If
        If strKessanDate = "NULL" Then
            MsgBox("決算処理は未処理です")
            Exit Sub
        End If

        '決算日をNULLに書き換える
        If SeisanForm.SetKessanDate(nendo, "NULL") = False Then
            MsgBox("データベース上の決算日の書換えに失敗しました")
            Exit Sub
        End If
        'データベース上のテーブルを更新したので、ds0をクリアしてds0にテーブルを読み戻す
        ds0.Clear()
        ReadCommonTable()

        '仕訳帳のデータの内、remarksが「決算」の行をすべて削除する。
        Dim strTable As String = TableShiwake(TabControl1.SelectedIndex)
        Dim strSQL As String = "delete from " & strTable & " where remarks = '決算'"
        If NonQueryCommand(conFY, strSQL) = False Then
            Debug.Print("SQL: " & strSQL)
        End If
        MsgBox("仕訳帳から決算に関連する項目を削除し、決算日を未記入にしました")
    End Sub

    Private Sub 現金出納帳ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 現金出納帳ToolStripMenuItem.Click
        GenkinEditForm.Show()
    End Sub

    Private Sub 仕訳帳ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 仕訳帳ToolStripMenuItem.Click
        ShiwakeEditForm.Show()
    End Sub

    Private Sub 終了XToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 終了XToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub アバウトAToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles アバウトAToolStripMenuItem.Click
        MsgBox("会計さん = kaikei3 " & vbCrLf & vbTab & "version 1.0 " & _
               vbCrLf & vbTab & "2014.02.05" & vbCrLf & vbTab & "by H.NAMVA")
    End Sub

    Private Sub ファイルインポートIToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ファイルインポートIToolStripMenuItem.Click
        FileInportForm.ShowDialog()
    End Sub
End Class
