﻿Public Class SeisanForm
    Private ds As New DataSet
    Private includeGenkasyokyakuFlag As Boolean

    Private Sub AddZandakaDGV(ByVal zandaka As Integer, ByVal code As Integer)
        Dim dt As New DataTable
        Dim dr() As DataRow
        Dim zDr, zCr, sDr, sCr, bDr, bCr As String

        dt = Form1.ds0.Tables("kanjokamoku")
        dr = dt.Select("code = " & code.ToString)
        zDr = ""
        zCr = ""
        sDr = ""
        sCr = ""
        bDr = ""
        bCr = ""
        Select Case dr(0).Item("kanjo") 'codeによって残高の数値を記入する欄を選択する
            Case 1 '貸借対照表勘定（資産）
                zDr = zandaka.ToString
                bDr = zandaka.ToString
                Dgv.Rows.Add(code.ToString, dr(0).Item("kamokumei"), zDr, zCr, sDr, sCr, bDr, bCr)
            Case 2 '貸借対照表勘定（負債）
                zandaka *= -1
                zCr = zandaka.ToString
                bCr = zandaka.ToString
                Dgv.Rows.Add(code.ToString, dr(0).Item("kamokumei"), zDr, zCr, sDr, sCr, bDr, bCr)
            Case 3 '貸借対照表勘定（資本）
                zandaka *= -1
                zCr = zandaka.ToString
                bCr = zandaka.ToString
                Dgv.Rows.Add(code.ToString, dr(0).Item("kamokumei"), zDr, zCr, sDr, sCr, bDr, bCr)
            Case 4 '損益計算書勘定（費用）
                zDr = zandaka.ToString
                sDr = zandaka.ToString
                If dr(0).Item("kamokumei") = "減価償却費" Then
                    includeGenkasyokyakuFlag = True
                End If
                Dgv.Rows.Add(code.ToString, dr(0).Item("kamokumei"), zDr, zCr, sDr, sCr, bDr, bCr)
            Case 5 '損益計算書勘定（収益）
                zandaka *= -1
                zCr = zandaka.ToString
                sCr = zandaka.ToString
                Dgv.Rows.Add(code.ToString, dr(0).Item("kamokumei"), zDr, zCr, sDr, sCr, bDr, bCr)
        End Select
    End Sub

    Private Sub SeisanForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strTable As String = Form1.TableMotocho(Form1.TabControl1.SelectedIndex)
        Dim strConditions As String = "order by kamoku, yyyymmdd, id"
        Dim strItems As String = "*"
        Dim code As Integer
        Dim zandaka As Integer = 0
        Dim PrevCode As Integer
        Dim rows As Integer
        Dim DrAmount As Integer = 0
        Dim CrAmount As Integer = 0

        includeGenkasyokyakuFlag = False '減価償却費フラグをFalseに
        Label1.Text = Form1.LbNendo.Text
        Label2.Text = Form1.kaikeikubun(Form1.TabControl1.SelectedIndex)
        Dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Dgv.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        Dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight

        '総勘定元帳を一行づつ読んで勘定科目ごとの残高を計算して記入
        If DataBaseModule.FillTablePartial(ds, strTable, strItems, strConditions, Form1.conFY) = False Then
            'テーブルの行数がゼロならメッセージボックスに表示して中止する
            MsgBox("テーブル(" & strTable & ")の行数がゼロでしたので処理を中止します")
            Me.Close()
        End If
        code = ds.Tables(strTable).Rows(0).Item("kamoku")
        PrevCode = code
        rows = ds.Tables(strTable).Rows.Count
        For i = 0 To rows - 1
            code = ds.Tables(strTable).Rows(i).Item("kamoku")
            If code <> PrevCode Then
                '勘定科目の境目なのでDataGridViewに行を追加し、残高をクリアする
                zandaka = DrAmount - CrAmount
                AddZandakaDGV(zandaka, PrevCode) 'DataGridViewに行を追加
                PrevCode = code
                DrAmount = 0
                CrAmount = 0
            End If
            If IsDBNull(ds.Tables(strTable).Rows(i).Item("DrAmount")) = False Then
                DrAmount += ds.Tables(strTable).Rows(i).Item("DrAmount")
            End If
            If IsDBNull(ds.Tables(strTable).Rows(i).Item("CrAmount")) = False Then
                CrAmount += ds.Tables(strTable).Rows(i).Item("CrAmount")
            End If
        Next
        zandaka = DrAmount - CrAmount
        AddZandakaDGV(zandaka, code) 'DataGridViewに行を追加
        '残高試算表・損益計算書・貸借対照表の借方・貸方合計を計算
        Dim zDr As Integer = 0
        Dim zCr As Integer = 0
        Dim sDr As Integer = 0
        Dim sCr As Integer = 0
        Dim bDr As Integer = 0
        Dim bCr As Integer = 0
        Dim ival As Integer
        rows = Dgv.Rows.Count
        For i = 0 To rows - 1
            '残高試算表
            If Integer.TryParse(Dgv.Rows(i).Cells(2).Value, ival) Then
                zDr += ival
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(3).Value, ival) Then
                zCr += ival
            End If
            '損益計算書
            If Integer.TryParse(Dgv.Rows(i).Cells(4).Value, ival) Then
                sDr += ival
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(5).Value, ival) Then
                sCr += ival
            End If
            '貸借対照表
            If Integer.TryParse(Dgv.Rows(i).Cells(6).Value, ival) Then
                bDr += ival
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(7).Value, ival) Then
                bCr += ival
            End If
        Next
        '残高試算表に合計を記入
        Dgv.Rows.Add("", "", zDr.ToString("C"), zCr.ToString("C"), "", "", "", "")
        '損益計算書の純利益を計算して記入
        Dim sJunrieki As Integer
        sJunrieki = sCr - sDr
        '貸借対照表の純利益を計算して記入
        Dim bJunrieki As Integer
        bJunrieki = bDr - bCr
        Dgv.Rows.Add("", "純利益", "", "", sJunrieki.ToString("C"), "", "", bJunrieki.ToString("C"))
        Dgv.Rows.Add("", "", "", "", (sJunrieki + sDr).ToString("C"), sCr.ToString("C"), bDr.ToString("C"), (bJunrieki + bCr).ToString("C"))
        '先頭行から金額を見易くするために￥を付けて3桁ごとにコンマを入れて通貨表示にする
        '本当は、最初からToString("C")としたいところだが、そのように表現するとInteger.Parseで整数に変換できなくなるので
        '仕方なく、最後に参照する必要がなくなってから書式を変換して表示している
        For i = 0 To rows - 1
            If Integer.TryParse(Dgv.Rows(i).Cells(2).Value, ival) Then
                Dgv.Rows(i).Cells(2).Value = ival.ToString("C")
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(3).Value, ival) Then
                Dgv.Rows(i).Cells(3).Value = ival.ToString("C")
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(4).Value, ival) Then
                Dgv.Rows(i).Cells(4).Value = ival.ToString("C")
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(5).Value, ival) Then
                Dgv.Rows(i).Cells(5).Value = ival.ToString("C")
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(6).Value, ival) Then
                Dgv.Rows(i).Cells(6).Value = ival.ToString("C")
            End If
            If Integer.TryParse(Dgv.Rows(i).Cells(7).Value, ival) Then
                Dgv.Rows(i).Cells(7).Value = ival.ToString("C")
            End If
        Next
    End Sub

    Private Function ToInteger(ByVal strInteger As String, ByRef value As Integer) As Boolean
        Dim index As Integer
        Dim indexOfMinus As Integer
        Dim minus As Boolean = False
        Dim strRep As String = ""
        ToInteger = False
        value = 0

        Try
            If strInteger.Length = 0 Then
                Exit Function
            End If
            indexOfMinus = strInteger.IndexOf("-")
            index = strInteger.IndexOf(Chr(92).ToString)
            If indexOfMinus >= 0 Then
                If indexOfMinus < index Then
                    minus = True
                End If
            End If
            If index < 0 Then
                strRep = strInteger
            Else
                strRep = strInteger.Substring(index + 1)
            End If
            strRep = strRep.Replace(",", "")
            value = Integer.Parse(strRep)
            If minus Then
                value *= -1
            End If
            ToInteger = True

        Catch ex As Exception
            Debug.Print("整数として不適切な値のため変換できませんでした。" & strRep)
        End Try
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim title As String = ""
        Dim columns As String = ""
        Dim Line As String = ""
        Dim rows As Integer
        Dim i, j As Integer
        Dim celldata As Integer

        SaveFileDialog1.FileName = ""
        SaveFileDialog1.Filter = "CSV files (*.csv)|*.csv|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            'ファイルをオープンする
            Dim textFile As System.IO.StreamWriter
            textFile = New System.IO.StreamWriter(SaveFileDialog1.FileName, False, System.Text.Encoding.GetEncoding("shift_jis"))
            title = "精算表," & Label1.Text & "," & Label2.Text
            textFile.WriteLine(title)   '最初の行にタイトルを書き出す
            columns = ",残高試算表,,損益計算書,,貸借対照表"
            textFile.WriteLine(columns) '次にカラム名を書き出す
            columns = "勘定科目,借方,貸方,借方,貸方,借方,貸方"
            textFile.WriteLine(columns)
            'テーブルの行数だけファイルに書き出す
            rows = Dgv.Rows.Count
            For i = 0 To rows - 2 '最下行は空白のため処理しないので-2としている
                Line = Dgv.Rows(i).Cells(1).Value '勘定科目
                For j = 2 To 7
                    If (Dgv.Rows(i).Cells(j).Value).IndexOf(Chr(92).ToString) >= 0 Then
                        If ToInteger(Dgv.Rows(i).Cells(j).Value, celldata) Then
                            Line &= "," & celldata.ToString
                        Else
                            Line &= ","
                        End If
                    Else
                        Line &= ","
                    End If
                Next
                textFile.WriteLine(Line)
            Next
            textFile.Close()
            '何行分のデータを書いたのかをメッセージボックスに表示して終了する
            MsgBox(i.ToString & "行分のデータを書き出しました")
        End If
    End Sub

    Public Function GetKanjo(ByVal code As String, ByRef kanjo As Integer) As Boolean
        'Dim dt As New DataTable
        Dim dr() As DataRow
        GetKanjo = False
        dr = Form1.ds0.Tables("kanjokamoku").Select("code = " & "'" & code & "'")
        If dr.Count > 0 Then
            GetKanjo = True
            kanjo = dr(0).Item("kanjo")
        End If
    End Function

    Public Function GetKimatsuDate(ByVal nendo As Integer, ByRef hizuke As String) As Boolean
        Dim dr() As DataRow
        GetKimatsuDate = False
        dr = Form1.ds0.Tables("kaikeinendo").Select("nendo = " & "'" & Form1.nendo.ToString & "'")
        If dr.Count > 0 Then
            GetKimatsuDate = True
            hizuke = dr(0).Item("kimatsu")
            hizuke = hizuke.Replace("/"c, "-"c)
        End If
    End Function

    Public Function SetKessanDate(ByVal nendo As Integer, ByVal hizuke As String) As Boolean
        Dim strSQL As String = "update kaikeinendo SET "

        SetKessanDate = False
        Try
            Select Case Form1.TabControl1.SelectedIndex
                Case 0
                    strSQL &= "kessan1 = "
                Case 1
                    strSQL &= "kessan2 = "
                Case 2
                    strSQL &= "kessan3 = "
            End Select
            If hizuke = "NULL" Then
                strSQL &= "NULL"
            Else
                strSQL &= "'" & hizuke & "'"
            End If
            strSQL &= " where nendo = '" & nendo.ToString & "';"
            If NonQueryCommand(Form1.conStr, strSQL) = False Then
                Debug.Print("SQL: " & strSQL)
            Else
                SetKessanDate = True
            End If
        Catch ex As Exception
            Debug.Print(ex.Message)
        End Try        
    End Function

    Public Function GetKessanDate(ByVal nendo As Integer, ByRef hizuke As String) As Boolean
        Dim dr() As DataRow
        GetKessanDate = False
        dr = Form1.ds0.Tables("kaikeinendo").Select("nendo = " & "'" & Form1.nendo.ToString & "'")
        If dr.Count > 0 Then
            Select Case Form1.TabControl1.SelectedIndex
                Case 0
                    If IsDBNull(dr(0).Item("kessan1")) = False Then
                        hizuke = dr(0).Item("kessan1")
                    Else
                        hizuke = "NULL"
                    End If
                Case 1
                    If IsDBNull(dr(0).Item("kessan2")) = False Then
                        hizuke = dr(0).Item("kessan2")
                    Else
                        hizuke = "NULL"
                    End If
                Case 2
                    If IsDBNull(dr(0).Item("kessan3")) = False Then
                        hizuke = dr(0).Item("kessan3")
                    Else
                        hizuke = "NULL"
                    End If
            End Select
            GetKessanDate = True
        End If
    End Function

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        '損益計算書勘定の各科目（kanjokamokuのkanjoが4または5の科目）の残高を「損益勘定」に振替える
        Dim rows As Integer = Dgv.Rows.Count
        Dim i As Integer
        Dim kanjo As Integer
        Dim strTable As String = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)
        Dim strSQL As String = ""
        Dim zandaka As Integer
        Dim soneki_kamoku() As String = {"1001", "2001", "3001"} '損益の科目コード（農業、事業、家計）の順
        Dim zandaka_kamoku() As String = {"1002", "2002", "3002"} '損益の科目コード（農業、事業、家計）の順
        Dim motoirekin_kamoku() As String = {"1301", "2301", "3301"} '元入金の科目コード（農業、事業、家計）の順
        Dim kimatsubi As String = ""
        Dim junrieki As Integer
        Dim strKessanDate As String = ""

        If includeGenkasyokyakuFlag = False Then
            Dim result As DialogResult = MsgBox("減価償却費が見当たりませんが、決算処理を続行しますか？", MsgBoxStyle.OkCancel)
            If DialogResult = Windows.Forms.DialogResult.Cancel Then
                Exit Sub
            End If
            'Else
            '    MsgBox("減価償却費が見込まれています")
        End If

        If GetKessanDate(Form1.nendo, strKessanDate) = False Then
            MsgBox("決算日の取得に失敗しました")
            Exit Sub
        End If
        If strKessanDate <> "NULL" Then
            MsgBox("既に決算処理により帳簿類が締め切られています　" &
                   strKessanDate)
            Exit Sub
        End If

        If GetKimatsuDate(Form1.nendo, kimatsubi) = False Then
            MsgBox("期末日の取得に失敗しました")
            Exit Sub
        End If
        
        For i = 0 To rows - 1
            'kanjokamokuテーブルを参照してkanjoの値（整数値）を得る
            If GetKanjo(Dgv.Rows(i).Cells(0).Value, kanjo) Then
                If kanjo = 4 Then '費用勘定なので、借方（Cell(2)）に残高がある
                    If ToInteger(Dgv.Rows(i).Cells(2).Value, zandaka) Then
                        strSQL = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                                   & " values('" & kimatsubi & "', '" _
                                   & soneki_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & zandaka & "', '" _
                                   & Dgv.Rows(i).Cells(0).Value & "', '" & zandaka & "', '" _
                                   & "決算" & "');"
                        'Debug.Print(strSQL)
                    Else
                        MsgBox("精算表の値が異常なため決算処理を中止しました")
                        'Debug.Print("dgv(" & i.ToString & ").Cells(2).Value " & Dgv.Rows(i).Cells(2).Value)
                        Exit Sub
                    End If

                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                ElseIf kanjo = 5 Then '収益勘定なので、貸方（Cell(3)）に残高がある
                    If ToInteger(Dgv.Rows(i).Cells(3).Value, zandaka) Then
                        strSQL = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                                   & " values('" & kimatsubi & "', '" _
                                   & Dgv.Rows(i).Cells(0).Value & "', '" & zandaka & "', '" _
                                   & soneki_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & zandaka & "', '" _
                                   & "決算" & "');"
                        'Debug.Print(strSQL)
                    Else
                        MsgBox("精算表の値が異常なため決算処理を中止しました")
                        'Debug.Print("dgv(" & i.ToString & ").Cells(2).Value " & Dgv.Rows(i).Cells(2).Value)
                        Exit Sub
                    End If

                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                End If
            Else
                If Dgv.Rows(i).Cells(1).Value = "純利益" Then
                    If ToInteger(Dgv.Rows(i).Cells(4).Value, junrieki) = False Then
                        MsgBox("精算表の値が異常な(純利益が見当たらない）ため決算処理を中止しました")
                        Exit Sub
                    Else
                        Debug.Print("純利益=" & junrieki.ToString)
                    End If
                End If
            End If
        Next
        '純利益を「元入金」に振替える（借方：損益　貸方：元入金）
        strSQL = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                                   & " values('" & kimatsubi & "', '" _
                                   & soneki_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & junrieki & "', '" _
                                   & motoirekin_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & junrieki & "', '" _
                                   & "決算" & "');"
        'Debug.Print(strSQL)
        If NonQueryCommand(Form1.conFY, strSQL) = False Then
            Debug.Print("SQL: " & strSQL)
        End If
        '貸借対照表勘定の各科目の残高を「残高」に振替える
        For i = 0 To rows - 1
            'kanjokamokuテーブルを参照してkanjoの値（整数値）を得る
            If GetKanjo(Dgv.Rows(i).Cells(0).Value, kanjo) Then
                If kanjo = 1 Then '資産勘定なので、借方（Cell(2)）に残高がある
                    If ToInteger(Dgv.Rows(i).Cells(2).Value, zandaka) Then
                        strSQL = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                                   & " values('" & kimatsubi & "', '" _
                                   & zandaka_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & zandaka & "', '" _
                                   & Dgv.Rows(i).Cells(0).Value & "', '" & zandaka & "', '" _
                                   & "決算" & "');"
                        'Debug.Print(strSQL)
                    Else
                        MsgBox("精算表の値が異常なため決算処理を中止しました")
                        'Debug.Print("dgv(" & i.ToString & ").Cells(2).Value " & Dgv.Rows(i).Cells(2).Value)
                        Exit Sub
                    End If

                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                ElseIf kanjo = 2 Or kanjo = 3 Then '負債・資本勘定なので、貸方（Cell(3)）に残高がある
                    If ToInteger(Dgv.Rows(i).Cells(3).Value, zandaka) Then
                        If Dgv.Rows(i).Cells(0).Value = motoirekin_kamoku(Form1.TabControl1.SelectedIndex) Then
                            '元入金の場合は、先ほど振替えた純利益を加算して残高とする
                            zandaka += junrieki
                        End If
                        strSQL = "insert into " & strTable & "(yyyymmdd, DrCode, DrAmount, CrCode, CrAmount, remarks)" _
                                   & " values('" & kimatsubi & "', '" _
                                   & Dgv.Rows(i).Cells(0).Value & "', '" & zandaka & "', '" _
                                   & zandaka_kamoku(Form1.TabControl1.SelectedIndex) & "', '" & zandaka & "', '" _
                                   & "決算" & "');"
                        'Debug.Print(strSQL)
                    Else
                        MsgBox("精算表の値が異常なため決算処理を中止しました")
                        'Debug.Print("dgv(" & i.ToString & ").Cells(2).Value " & Dgv.Rows(i).Cells(2).Value)
                        Exit Sub
                    End If

                    If NonQueryCommand(Form1.conFY, strSQL) = False Then
                        Debug.Print("SQL: " & strSQL)
                    End If
                End If
            End If
        Next
        MsgBox("決算処理を終了し、帳簿類を締め切りました。" & vbCrLf & _
               "念のために精算表をファイルに出力することをお勧めします。")

        Dim strToday As String = Now().ToString("yyyy-MM-dd")
        If SetKessanDate(Form1.nendo, strToday) = False Then
            Debug.Print("kaikeinendoテーブルの決算日付の更新に失敗しました")
        End If
        'データベース上のテーブルを更新したので、ds0をクリアしてds0にテーブルを読み戻す
        Form1.ds0.Clear()
        Form1.ReadCommonTable()
    End Sub

End Class