﻿Public Class ShiwakeEditForm
    Private ds2 As New DataSet

    Private Sub ShiwakeEditForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strTable As String = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)
        Dim strConditions As String = "order by yyyymmdd desc, id desc"
        Dim col_width() As Integer = {50, 70, 60, 80, 60, 80, 300}
        Dim col_header() As String = {"仕丁", "日付", "借方#", "借方金額", "貸方#", "貸方金額", "摘要"}
        Dim strKessanDate As String = ""
        If SeisanForm.GetKessanDate(Form1.nendo, strKessanDate) = False Then
            MsgBox("決算日の取得に失敗しました")
            Exit Sub
        End If
        If strKessanDate <> "NULL" Then
            MsgBox("既に決算処理により帳簿類が締め切られています　" & strKessanDate & vbCrLf & _
                   "削除ボタンや編集ボタンは使用できません")
            BtnDelete.Enabled = False
            BtnEdit.Enabled = False
        End If

        If DataBaseModule.FillTablePartial(ds2, strTable, "*", strConditions, Form1.conFY) = False Then
            MsgBox("仕訳帳テーブルが開けませんでした")
            ds2.Dispose()
            Exit Sub
        Else
            Me.DataGridView1.DataSource = ds2.Tables(strTable)
            For i = 0 To DataGridView1.Columns.Count - 1
                DataGridView1.Columns(i).Width = col_width(i)
                DataGridView1.Columns(i).HeaderText = col_Header(i)
            Next
            '金額の欄は右揃えにする
            DataGridView1.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DataGridView1.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DataGridView1.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            DataGridView1.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            Me.ActiveControl = DataGridView1
        End If
    End Sub

    Private Sub BtnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDelete.Click
        Dim strTable As String = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)
        Dim row As DataGridViewRow
        Dim strSQL As String = ""

        For Each row In DataGridView1.SelectedRows
            If Not row.IsNewRow Then
                strSQL = "delete from " & strTable & " where id = '" & row.Cells(0).Value & "';"
                If NonQueryCommand(Form1.conFY, strSQL) = False Then
                    Debug.Print("SQL: " & strSQL)
                End If
                DataGridView1.Rows.Remove(row)
            End If
        Next row
    End Sub

    Private Sub BtnEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEdit.Click
        Dim strTable As String = Form1.TableShiwake(Form1.TabControl1.SelectedIndex)
        Dim row As DataGridViewRow
        Dim strSQL As String = "update " & strTable & " set "
        Dim strDate As String

        row = DataGridView1.Rows(DataGridView1.CurrentCell.RowIndex)
        If Not row.IsNewRow Then
            strDate = row.Cells(1).Value
            strDate.Replace("/", "-")
            strSQL &= "yyyymmdd = '" & strDate & "', "
            strSQL &= "DrCode = '" & row.Cells(2).Value & "', "
            strSQL &= "DrAmount = '" & row.Cells(3).Value & "', "
            strSQL &= "CrCode = '" & row.Cells(4).Value & "', "
            strSQL &= "CrAmount = '" & row.Cells(5).Value & "', "
            strSQL &= "remarks = '" & row.Cells(6).Value & "' "
            strSQL &= "where id = '" & row.Cells(0).Value & "';"
            If NonQueryCommand(Form1.conFY, strSQL) = False Then
                Debug.Print("SQL: " & strSQL)
            Else
                MsgBox("仕訳帳を更新しました")
            End If
        End If
    End Sub
End Class